C+    ioutmajor.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM WRITES MESSAGES THAT ARE DESIGNATED "major"
C+    TO THE SCREEN AND/OR info.txt FILE AS DETERMINED BY THE 
C+    VALUE OF INFO
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*71 AERROR,BERROR
      OPEN(75,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(75)
      READ(75,*)IDUMMY,INFO
      CLOSE(75)
      OPEN(77,FILE='../temp_files/info.txt'
     &,STATUS='OLD')
      REWIND(77)
      DO 721 I721=1,500000
         READ(77,*,END=722)
 721  CONTINUE
      AERROR='ERROR: LOOP 721 FINISHED IN ioutmajor.f'
      IF (INFO.GE.2) THEN
         WRITE(6,9000)AERROR
      ENDIF
      IF (INFO.LE.4) THEN
         WRITE(77,9300)
         WRITE(77,9000)AERROR
      ENDIF
      OPEN(42,FILE='../temp_files/errors.txt'
     &,STATUS='OLD')
      REWIND(42)
      DO 731 I731=1,10000
         READ(42,*,END=732)
 731  CONTINUE
      BERROR='ERROR: LOOP 731 FINISHED IN ioutmajor.f'
      IF (INFO.GE.2) THEN
         WRITE(6,9000)BERROR
      ENDIF
      IF (INFO.LE.4) THEN
         WRITE(77,9000)BERROR
      ENDIF
      WRITE(42,9200)
      WRITE(42,9000)AERROR
      WRITE(42,9000)BERROR
      CLOSE(42)
      CLOSE(77)
      STOP
 732  BACKSPACE(42)
      WRITE(42,9000)AERROR
      CLOSE(42)
      CLOSE(77)
      STOP
 722  BACKSPACE(77)
      CALL IOUT(INFO,'major')
      CLOSE(77)
      STOP
 9000 FORMAT(A71)
 9200 FORMAT('************** WARNING: ******************',/,
     &       ' THE ERROR FILE SEEMS TO BE VERY LONG, AS',/
     &       ' INDICATED BY THE NEXT MESSAGE. ANY OTHER',/, 
     &       ' ERROR MESSAGES THAT APPEARED AFTER THIS',/,
     &       ' POINT IN THE FILE HAVE BEEN LOST')
 9300 FORMAT('************** WARNING: ******************',/,
     &       ' THE INFO FILE SEEMS TO BE VERY LONG, AS',/
     &       ' INDICATED BY THE NEXT MESSAGE. ANY OTHER',/, 
     &       ' ERROR MESSAGES THAT APPEARED AFTER THIS',/,
     &       ' POINT IN THE FILE HAVE BEEN LOST')
      END
